// simple server listening on port 6543
// no error checking (except for bind)

#include <sys/socket.h>  // socket(), bind(), ...
#include <netinet/in.h>  // struct sockaddr_in
#include <strings.h>	 // bzero(), ...
#include <unistd.h>	 // read(), write(), close(), ...
#include <stdio.h>	 // sprintf(), fprintf(), perror(), ...
#include <stdlib.h>      // exit()
#include <arpa/inet.h>	 // inet_ntoa(), ...
#include <string.h>	 // strlen(), strncmp(), 
#include <errno.h>       // global var errno

#define CMDLEN 2
#define BUFLEN 100

int main (int argc, char **argv)
{
  int                 listenfd, connfd ;
  struct sockaddr_in  servaddr, cliaddr, socketinfo ;
  socklen_t           len ;
  char                outstring[BUFLEN], inbuf[BUFLEN] ;
  int                 readlen, quit ;
 

  listenfd = socket(AF_INET, SOCK_STREAM, 0) ;

  bzero(&servaddr, sizeof(servaddr)) ;
  servaddr.sin_family = AF_INET ;
  servaddr.sin_addr.s_addr = htonl(INADDR_ANY) ;
  servaddr.sin_port = htons(6543) ;

  if (bind(listenfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) == -1) {
    perror("bind error") ;
    exit(1) ;
  } ;  
 
  listen(listenfd, 5) ;

  fprintf(stderr, "\nServer started ...\n") ;

  while(1) {
    fprintf(stderr, "Waiting for new connection ...\n") ;
    len = sizeof(cliaddr) ;
    connfd = accept(listenfd, (struct sockaddr *) &cliaddr, &len) ;

    fprintf(stderr, "Got new connection from %s:%d\n\r", inet_ntoa(cliaddr.sin_addr), ntohs(cliaddr.sin_port)) ;
    
    sprintf(outstring, "Welcome to AppServ, please enter your command\n") ;
    write(connfd, outstring, strlen(outstring)) ;

    quit = 0 ;
    do {
      readlen = read(connfd, inbuf, BUFLEN) ;
      inbuf[readlen] = '\0' ;
 
      fprintf(stderr,"got command: %s",inbuf) ;

      if (strncmp(inbuf, "si", CMDLEN) == 0) {
        len = sizeof(socketinfo) ;
        getsockname(connfd, (struct sockaddr *) &socketinfo, &len) ;
        sprintf(outstring, "Server IP %s, port %d\n\r", inet_ntoa(socketinfo.sin_addr), ntohs(socketinfo.sin_port)) ;
        write(connfd, outstring, strlen(outstring)) ;
      }

      else if (strncmp(inbuf, "ci", CMDLEN) == 0) {
        len = sizeof(socketinfo) ;
        getpeername(connfd, (struct sockaddr *) &socketinfo, &len) ;
        sprintf(outstring, "Client IP %s, port %d\n\r", inet_ntoa(socketinfo.sin_addr), ntohs(socketinfo.sin_port)) ;
        write(connfd, outstring, strlen(outstring)) ;
      }
    
      else if (strncmp(inbuf, "hi", CMDLEN) == 0) {
        sprintf(outstring, "nice to meet you\n") ;
        write(connfd, outstring, strlen(outstring)) ;
      }
    
      else if (strncmp(inbuf, "ex", CMDLEN) == 0) {
        sprintf(outstring, "see you next time\n") ;
        write(connfd, outstring, strlen(outstring)) ;
        quit = 1 ;
      }
    
      else {
        sprintf(outstring, "don't understand you\n") ;
        write(connfd, outstring, strlen(outstring)) ;
      } ;
    } while (!quit) ;
  
    close(connfd) ;
  } ;
} ;

 
